moSetGetBga = {};

function moSetGetBga:setBgaUpdate(self, openSlot)
	if tonumber(openSlot) == 1 and moBgaMapObjects.catcher == 0 then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "bga ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."bga ";end;
		return;
	end;
	if tonumber(openSlot) == 2 and moBgaMapObjects.silo == 0 then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "silageSilos ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."silageSilos ";end;
		return;
	end;
	if tonumber(openSlot) == 1 or moGuiMiniPDAsetGet.combiBgaSilo then
		for a=1, moBgaMapObjects.catcher do
			local objCreate = moBgaMapObjects["catcher".. a].objCreate;
			moBgaMapObjects["catcher".. a].fillLevel = Utils.getNoNil(objCreate.bunkerFillLevel, 0);
			if objCreate.liquidManureSiloTrigger ~= nil then
				moBgaMapObjects["catcher".. a].liquidManureFillLevel = Utils.getNoNil(objCreate.liquidManureSiloTrigger.fillLevel, 0);
				moBgaMapObjects["catcher".. a].liquidManureCapacity = Utils.getNoNil(objCreate.liquidManureSiloTrigger.capacity, 0);
			else				
				moBgaMapObjects["catcher".. a].liquidManureFillLevel = -1;
				moBgaMapObjects["catcher".. a].liquidManureCapacity = -1;
			end;
		end;
	end;
	if tonumber(openSlot) == 2 or moGuiMiniPDAsetGet.combiBgaSilo then
		for a=1, moBgaMapObjects.silo do		
			local obj = moBgaMapObjects["silo".. a].obj;
			local stateOld = moBgaMapObjects["silo".. a].state;
			local fillLevelOld = Utils.getNoNil(obj.fillLevel, 0);
			moBgaMapObjects["silo".. a].fillLevel = Utils.getNoNil(obj.fillLevel, 0);		
			moBgaMapObjects["silo".. a].state = Utils.getNoNil(obj.state, 0);
			moBgaMapObjects["silo".. a].compactFillLevel = Utils.getNoNil(obj.compactedFillLevel, 0);
			moBgaMapObjects["silo".. a].compact = Utils.getNoNil(obj.compact, 0);
			moBgaMapObjects["silo".. a].fermentingTime = Utils.getNoNil(obj.fermentingTime, 0);
			moBgaMapObjects["silo".. a].fermentingDuration = Utils.getNoNil(obj.fermentingDuration, 0);
			local objCreate = moBgaMapObjects["silo".. a].objCreate;
			if tonumber(stateOld) ~= tonumber(moBgaMapObjects["silo".. a].state) then
				moBgaMapObjects["silo".. a].fillType = "";
				moBgaMapObjects["silo".. a].outPutFillType = "Silage";
				if objCreate.acceptedFillTypes ~= nil then
					for acceptedFillTypes, v in pairs(objCreate.acceptedFillTypes) do
						if v then
							local desc = Fillable.fillTypeIndexToDesc[acceptedFillTypes];
							if desc ~= nil then
								local fruitName = moFillTypes[desc.index].fruitName;
								moBgaMapObjects["silo".. a].fillType = moBgaMapObjects["silo".. a].fillType.. fruitName.. " ";
							end;
						end;
					end;
				end;
			end;
			if moBgaMapObjects.silageExtension then					
				if tonumber(stateOld) ~= tonumber(moBgaMapObjects["silo".. a].state) or tonumber(fillLevelOld) ~= tonumber(moBgaMapObjects["silo".. a].fillLevel) then
					moBgaMapObjects["silo".. a].isRotten = false;
					moBgaMapObjects["silo".. a].rottenFillLevel = 0;
					moBgaMapObjects["silo".. a].potatosFillLevel = 0;
					moBgaMapObjects["silo".. a].grassFillLevel = 0;
					moBgaMapObjects["silo".. a].dry_grassFillLevel = 0;
					moBgaMapObjects["silo".. a].forageFillLevel = 0;				
					if tonumber(moBgaMapObjects["silo".. a].fillLevel ) > 0 and moBgaMapObjects["silo".. a].movingPlanes > 0 then					
						for b=1, moBgaMapObjects["silo".. a].movingPlanes do
							local movingPlanes = objCreate.bunkerSilo.movingPlanes[b];
							if not moBgaMapObjects["silo".. a].isRotten and movingPlanes.isRotten then moBgaMapObjects["silo".. a].isRotten = true;end;
							if movingPlanes.isRotten then moBgaMapObjects["silo".. a].rottenFillLevel = moBgaMapObjects["silo".. a].rottenFillLevel+movingPlanes.compactFillLevel;end;
							moBgaMapObjects["silo".. a].potatosFillLevel = moBgaMapObjects["silo".. a].potatosFillLevel+movingPlanes.fractionPotato;
							moBgaMapObjects["silo".. a].grassFillLevel = moBgaMapObjects["silo".. a].grassFillLevel+movingPlanes.fractionGrass;
							if movingPlanes.fractionGrass > 0.5 then
								moBgaMapObjects["silo".. a].dry_grassFillLevel = moBgaMapObjects["silo".. a].dry_grassFillLevel+movingPlanes.compactFillLevel;
							elseif movingPlanes.fractionGrass < 0.2 and movingPlanes.fractionPotato > 0.1 and movingPlanes.fractionPotato < 0.4 then 
								moBgaMapObjects["silo".. a].forageFillLevel = moBgaMapObjects["silo".. a].forageFillLevel+movingPlanes.compactFillLevel;
							end;
						end;
						if moBgaMapObjects["silo".. a].isRotten then
							if moBgaMapObjects["silo".. a].rottenFillLevel >= moBgaMapObjects["silo".. a].fillLevel then
								moBgaMapObjects["silo".. a].outPutFillType = unpack(moLanguage.extern['manure'.. moDefault.language])
							else
								if moBgaMapObjects["silo".. a].forageFillLevel > 0 then
									moBgaMapObjects["silo".. a].outPutFillType = moBgaMapObjects["silo".. a].outPutFillType.. " ".. unpack(moLanguage.extern['manure'.. moDefault.language]).. " ".. unpack(moLanguage.extern['forage'.. moDefault.language]);
								else
									moBgaMapObjects["silo".. a].outPutFillType = moBgaMapObjects["silo".. a].outPutFillType.. " ".. unpack(moLanguage.extern['manure'.. moDefault.language]);
								end;							
							end;
						end;
					end;
				end;			
			end;			
		end;
	end;	
end;

function moSetGetBga:setFirstBgaUpdate(self)	
	if moBgaMapObjects.catcher ~= 0 then
		for a=1, moBgaMapObjects.catcher do
			local objCreate = moBgaMapObjects["catcher".. a].objCreate;
			local obj = moBgaMapObjects["catcher".. a].obj;
			--local obj = moBgaMapObjects["catcher".. a].obj;
			moBgaMapObjects["catcher".. a].bgaName = "BGA";		
			moBgaMapObjects["catcher".. a].id = objCreate.id;				
			moBgaMapObjects["catcher".. a].fillLevel = Utils.getNoNil(objCreate.bunkerFillLevel, 0);
			if objCreate.liquidManureSiloTrigger ~= nil then
				moBgaMapObjects["catcher".. a].liquidManureFillLevel = Utils.getNoNil(objCreate.liquidManureSiloTrigger.fillLevel, 0);
				moBgaMapObjects["catcher".. a].liquidManureCapacity = Utils.getNoNil(objCreate.liquidManureSiloTrigger.capacity, 0);
			else
				moBgaMapObjects["catcher".. a].liquidManureFillLevel = -1;
				moBgaMapObjects["catcher".. a].liquidManureCapacity = -1;
			end;
			moBgaMapObjects["catcher".. a].capacity = Utils.getNoNil(objCreate.bunkerCapacity, 0);
			moBgaMapObjects["catcher".. a].speed = Utils.getNoNil(objCreate.bunkerUseSpeed, 25);
			moBgaMapObjects["catcher".. a].fillType = "";		
			if obj.stationName ~= nil and moStationes[obj.stationName] ~= nil then
				moBgaMapObjects["catcher".. a].bgaName = moStationes[obj.stationName].stationName;
			end;
			if obj. acceptedFillTypes ~= nil then
			--if moBGATrigger[a] ~= nil and moBgaMapObjects["catcher".. a].id ~= nil then			
				--local obj1 = g_currentMission.tipTriggers[moBGATrigger[a].bgaTrigger];			
				--if obj1 ~= nil then
					--local stationName = getUserAttribute(obj1.triggerId, "stationName");
					--if stationName ~= nil and moStationes[stationName] ~= nil then
					--	moBgaMapObjects["catcher".. a].bgaName = moStationes[stationName].stationName;
					--end;				
					for acceptedFillTypes, v in pairs(obj.acceptedFillTypes) do
						if v then
							local desc = Fillable.fillTypeIndexToDesc[acceptedFillTypes];
							if desc ~= nil then
								local fruitName = moFillTypes[desc.index].fruitName;
								moBgaMapObjects["catcher".. a].fillType = moBgaMapObjects["catcher".. a].fillType.. fruitName.. " ";
							end;
						end;
					end;				
				--end;			
			end;
		end;
	else
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "bga ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."bga ";end;
	end;
	if moBgaMapObjects.silo ~= 0 then
		for a=1, moBgaMapObjects.silo do
			local obj = moBgaMapObjects["silo".. a].obj;
			local objCreate = moBgaMapObjects["silo".. a].objCreate;
			moBgaMapObjects["silo".. a].id = obj.id;
			moBgaMapObjects["silo".. a].fillLevel = Utils.getNoNil(obj.fillLevel, 0);
			moBgaMapObjects["silo".. a].fillType = "";
			moBgaMapObjects["silo".. a].outPutFillType = "Silage";
			--local fruitName = objCreate:getFillType();
			--if not string.find(moBgaMapObjects["silo".. a].outPutFillType, fruitName) then moBgaMapObjects["silo".. a].outPutFillType = moBgaMapObjects["silo".. a].outPutFillType.. fruitName.. " ";end;
			if objCreate.acceptedFillTypes ~= nil then			
				for acceptedFillTypes, v in pairs(objCreate.acceptedFillTypes) do
					if v then
						local desc = Fillable.fillTypeIndexToDesc[acceptedFillTypes];
						if desc ~= nil then
							local fruitName = moFillTypes[desc.index].fruitName;
							moBgaMapObjects["silo".. a].fillType = moBgaMapObjects["silo".. a].fillType.. fruitName.. " ";
						end;
					end;
				end;
			end;
			moBgaMapObjects["silo".. a].movingPlanes = 0;
			moBgaMapObjects["silo".. a].state = Utils.getNoNil(obj.state, 0);
			moBgaMapObjects["silo".. a].capacity = Utils.getNoNil(obj.capacity, 0);
			moBgaMapObjects["silo".. a].compactFillLevel = Utils.getNoNil(obj.compactedFillLevel, 0);
			moBgaMapObjects["silo".. a].compact = Utils.getNoNil(obj.compact, 0);
			moBgaMapObjects["silo".. a].fermentingTime = Utils.getNoNil(obj.fermentingTime, 0);
			moBgaMapObjects["silo".. a].fermentingDuration = Utils.getNoNil(obj.fermentingDuration, 0);			
			moBgaMapObjects["silo".. a].potatosFillLevel = 0;
			moBgaMapObjects["silo".. a].grassFillLevel = 0;
			moBgaMapObjects["silo".. a].forageFillLevel = 0;
			moBgaMapObjects["silo".. a].dry_grassFillLevel = 0;
			moBgaMapObjects["silo".. a].forageFillLevel = 0;
			if moBgaMapObjects.silageExtension then
				moBgaMapObjects["silo".. a].movingPlanes = Utils.getNoNil(table.getn(objCreate.bunkerSilo.movingPlanes), 0);
				moBgaMapObjects["silo".. a].rottenFillLevel = 0;
				moBgaMapObjects["silo".. a].isRotten = false;
				if tonumber(moBgaMapObjects["silo".. a].fillLevel ) > 0 then				
					for b=1, moBgaMapObjects["silo".. a].movingPlanes do
						local movingPlanes = objCreate.bunkerSilo.movingPlanes[b];
						if not moBgaMapObjects["silo".. a].isRotten and movingPlanes.isRotten then moBgaMapObjects["silo".. a].isRotten = true;end;
						if movingPlanes.isRotten then moBgaMapObjects["silo".. a].rottenFillLevel = moBgaMapObjects["silo".. a].rottenFillLevel+movingPlanes.compactFillLevel;end;
						moBgaMapObjects["silo".. a].potatosFillLevel = moBgaMapObjects["silo".. a].potatosFillLevel+movingPlanes.fractionPotato;
						moBgaMapObjects["silo".. a].grassFillLevel = moBgaMapObjects["silo".. a].grassFillLevel+movingPlanes.fractionGrass;
						if movingPlanes.fractionGrass > 0.5 then
							moBgaMapObjects["silo".. a].dry_grassFillLevel = moBgaMapObjects["silo".. a].dry_grassFillLevel+movingPlanes.compactFillLevel;
						elseif movingPlanes.fractionGrass < 0.2 and movingPlanes.fractionPotato > 0.1 and movingPlanes.fractionPotato < 0.4 then 
							moBgaMapObjects["silo".. a].forageFillLevel = moBgaMapObjects["silo".. a].forageFillLevel+movingPlanes.compactFillLevel;
						end;					
					end;
					if moBgaMapObjects["silo".. a].isRotten then
						if moBgaMapObjects["silo".. a].rottenFillLevel >= moBgaMapObjects["silo".. a].fillLevel then
							moBgaMapObjects["silo".. a].outPutFillType = unpack(moLanguage.extern['manure'.. moDefault.language])
						else
							if moBgaMapObjects["silo".. a].forageFillLevel > 0 then
								moBgaMapObjects["silo".. a].outPutFillType = moBgaMapObjects["silo".. a].outPutFillType.. " ".. unpack(moLanguage.extern['manure'.. moDefault.language]).. " ".. unpack(moLanguage.extern['forage'.. moDefault.language]);
							else
								moBgaMapObjects["silo".. a].outPutFillType = moBgaMapObjects["silo".. a].outPutFillType.. " ".. unpack(moLanguage.extern['manure'.. moDefault.language]);
							end;							
						end;
					end;
				end;
			end;
		end;
	else
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "silageSilos ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."silageSilos ";end;
	end;
end;