moSetGetGreenHouse = {};

function moSetGetGreenHouse:setGreenHouseUpdate(self)	
	--moDefaultPlaceableGreenHouse.lengthGreenHouse = 0;
	--moDefaultPlaceableGreenHouse.greenHouse = "";
	moDefaultPlaceable.lengthGreenHouse = 0;
	moDefaultPlaceable.greenHouseFound = "";
	moDefault.warningGreenHouseProductivity = 100;
	moDefault.lengthGreenHouseFillName = 0;
	moGreenHouse = {};	
	function checkPlaceableGreenHouse(xmlModString, greenHouseName, modType, displayName, category)
		if xmlModString ~= nil then			
			setPlaceableGreenHouse(self, xmlModString, greenHouseName, modType, displayName, category)				
		end;
	end;
	--for a=1, moDefaultPlaceableGreenHouse.greenHouseSearch do
	--	local greenHouseType = nil;
	--	local xmlModString = nil;
	--	local greenHouseName = moDefaultPlaceableGreenHouse.greenHouseName[a];
	--	if string.find(tostring(greenHouseName), "_Ls", 0, true) then greenHouseType = "Ls";xmlModString = string.lower(moDefaultPlaceableGreenHouse.greenHouseMod[a]);end;
	--	if string.find(tostring(greenHouseName), "_Upk", 0, true) then greenHouseType = "Upk";xmlModString = string.lower(moDefault.gameDir.. moDefaultPlaceableGreenHouse.greenHouseMod[a]);end;
	--	if string.find(tostring(greenHouseName), "_Fmod", 0, true) then greenHouseType = "Fmod";xmlModString = string.lower(moDefault.gameDir.. moDefaultPlaceableGreenHouse.greenHouseMod[a])end;		
	--	if greenHouseType ~= nil and xmlModString ~= nil then			
	--		checkPlaceableGreenHouse(g_currentMission.placeables[xmlModString], greenHouseName, greenHouseType);
	--	end;
	--end;
	for a=1, moDefaultPlaceable.searchGreenHouse do
		local splitString = Utils.splitString(",", moDefaultPlaceable.greenHouse[a]);
		local xmlModString = string.lower(moDefault.gameDir.. splitString[2]);
		local greenHouseName = Utils.getNoNil(splitString[3], "greenhouse".. a); --moDefaultUpkPlaceable.treesName[a];
		local modType = splitString[1]; --moDefaultUpkPlaceable.treesName[a];
		if tostring(modType) == "ls" then xmlModString = string.lower(splitString[2]);end;		
		--if not modType then
			checkPlaceableGreenHouse(g_currentMission.placeables[xmlModString], greenHouseName.. "_".. modType, modType, greenHouseName, category);
		--end;		
	end;
	if moDefaultPlaceable.lengthGreenHouse == 0 then 
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "greenHouse ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."greenHouse ";end;	
	end;
end;

function setPlaceableGreenHouse(self, xmlModString, greenHouseName, modType, displayName, category)
	moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "greenHouse ", "");	
	if moGreenHouse[greenHouseName] == nil then
		--moDefaultPlaceableGreenHouse.lengthGreenHouse = moDefaultPlaceableGreenHouse.lengthGreenHouse+1;
		moDefaultPlaceable.lengthGreenHouse = moDefaultPlaceable.lengthGreenHouse+1;
		moGreenHouse[greenHouseName] = {};
		moGreenHouse[greenHouseName].modType = modType;
		moGreenHouse[greenHouseName].category = category;
		moGreenHouse[greenHouseName].length = 0;
		if moLanguage.extern[displayName.. moDefault.language] ~= nil then
			moGreenHouse[greenHouseName].greenHouseName = unpack(moLanguage.extern[displayName.. moDefault.language]);
		else
			moGreenHouse[greenHouseName].greenHouseName = displayName;
		end;		
		moGreenHouse[greenHouseName].capacityWater = 0;
		moGreenHouse[greenHouseName].fillLevelWater = 0;
		moGreenHouse[greenHouseName].capacityManure = 0;
		moGreenHouse[greenHouseName].fillLevelManure = 0;
		moGreenHouse[greenHouseName].modName = nil;
		moGreenHouse[greenHouseName].fillType = {};	
		moGreenHouse[greenHouseName].fillTypeName = {};
		moGreenHouse[greenHouseName].fillLevel = {};
		moGreenHouse[greenHouseName].capacity = {};
		moGreenHouse[greenHouseName].bestPrice = {};
		moGreenHouse[greenHouseName].productivity = 0;
		moGreenHouse[greenHouseName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;		
	local setFirstModName = false;	
	for k, v in pairs(xmlModString) do			
		moGreenHouse[greenHouseName].length = moGreenHouse[greenHouseName].length+1
		if tostring(modType) == "upk" then
			--moDefaultPlaceableGreenHouse.lengthGreenHouse = moDefaultPlaceableGreenHouse.lengthGreenHouse+1;			
			if not setFirstModName then setFirstModName = true;moGreenHouse[greenHouseName].modName = xmlModString[k].base.name;end;
			local a = 1;			
			for k1, v1 in pairs(xmlModString[k].base.p_flbs) do
				if moGreenHouse[greenHouseName].capacity[a] == nil then
					moGreenHouse[greenHouseName].capacity[a] = xmlModString[k].base.capacities.p_capacities[k1];
					moGreenHouse[greenHouseName].fillLevel[a] = xmlModString[k].base.p_flbs[k1].p_fillLevel;					
					local desc = Fillable.fillTypeIndexToDesc[k1];
					if desc ~= nil then
						moGreenHouse[greenHouseName].fillTypeName[a] = moFillTypes[desc.index].fruitName;
						if desc.name ~= "water" and desc.name ~= "seeds" and desc.name ~= "seeds2" and desc.name ~= "quellwasser" and desc.name ~= "manure" and desc.name ~= "compost" and desc.name ~= "fertilizer" then
							moGreenHouse[greenHouseName].bestPrice[a] = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
							moGreenHouse[greenHouseName].fillType[a] = false;
						else
							moGreenHouse[greenHouseName].bestPrice[a] = 0;
							moGreenHouse[greenHouseName].fillType[a] = true;
						end;
					else
						moGreenHouse[greenHouseName].fillTypeName[a] = "unknow";
						moGreenHouse[greenHouseName].bestPrice[a] = 0;
						moGreenHouse[greenHouseName].fillType[a] = false;
					end;
				else
					moGreenHouse[greenHouseName].capacity[a] = moGreenHouse[greenHouseName].capacity[a]+xmlModString[k].base.capacities.p_capacities[k1];				
					moGreenHouse[greenHouseName].fillLevel[a] = moGreenHouse[greenHouseName].fillLevel[a]+xmlModString[k].base.p_flbs[k1].p_fillLevel;				
				end;								
				a = a+1;
			end;
		end;
		if tostring(modType) == "ls" then
			--moDefaultPlaceableGreenHouse.lengthGreenHouse = moDefaultPlaceableGreenHouse.lengthGreenHouse+1;			
			moGreenHouse[greenHouseName].modName = "ls15";
			moGreenHouse[greenHouseName].capacityWater = moGreenHouse[greenHouseName].capacityWater+xmlModString[k].waterTankCapacity;
			moGreenHouse[greenHouseName].capacityManure = moGreenHouse[greenHouseName].capacityManure+xmlModString[k].manureCapacity;
			moGreenHouse[greenHouseName].fillLevelWater = moGreenHouse[greenHouseName].fillLevelWater+xmlModString[k].waterTankFillLevel;
			moGreenHouse[greenHouseName].fillLevelManure = moGreenHouse[greenHouseName].fillLevelManure+xmlModString[k].manureFillLevel;
		end;
		if tostring(modType) == "fs" then
			--moDefaultPlaceableGreenHouse.lengthGreenHouse = moDefaultPlaceableGreenHouse.lengthGreenHouse+1;
			moGreenHouse[greenHouseName].modName = "fabrikScript";			
			setTableGreenHouseFabrikScript(self, xmlModString[k], greenHouseName);
		end;				
	end;
	if moGreenHouse[greenHouseName].modName == nil then table.remove(moGreenHouse[greenHouseName]);return;end;	
	moDefaultPlaceable.greenHouseFound = moDefaultPlaceable.greenHouseFound.. greenHouseName.. " ";
	if tostring(modType) == "ls" or tostring(modType) == "upk" then
		setPlaceableGreenHouseProductivityColor(self, greenHouseName, modType);
	end;
	if tostring(modType) == "fs" then
		setGreenHouseProductivityMarhu(self, greenHouseName);
	end;	
end;

function setPlaceableGreenHouseProductivityColor(self, greenHouseName, modType)
	local capacity = 0;
	local fillLevel = 0;
	if tostring(modType) == "Upk" then
		for a=1, table.getn(moGreenHouse[greenHouseName].capacity) do
			if moGreenHouse[greenHouseName].fillType[a] then
				capacity = capacity+moGreenHouse[greenHouseName].capacity[a];
				fillLevel = fillLevel+moGreenHouse[greenHouseName].fillLevel[a];
			end;
		end;
	else
		capacity = capacity+moGreenHouse[greenHouseName].capacityWater+moGreenHouse[greenHouseName].capacityManure;	
		fillLevel = fillLevel+moGreenHouse[greenHouseName].fillLevelWater+moGreenHouse[greenHouseName].fillLevelManure;	
	end;	
	local ratio = string.format("%0.0f", Utils.getNoNil((fillLevel/capacity)*100, 0));
	moGreenHouse[greenHouseName].productivity = ratio;	
	moGreenHouse[greenHouseName].productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['green'];
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		moGreenHouse[greenHouseName].productivityColor = moGuiMiniPDAsetGet.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		moGreenHouse[greenHouseName].productivityColor = moGuiMiniPDAsetGet.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		moGreenHouse[greenHouseName].productivityColor = moGuiMiniPDAsetGet.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		moGreenHouse[greenHouseName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	if tonumber(moDefault.warningGreenHouseProductivity) >= tonumber(ratio) then 
		moDefault.warningGreenHouseProductivity = tonumber(ratio);	
	end;
end;

function setTableGreenHouseFabrikScript(self, xmlModString, greenHouseName)	
	local a = 1;
	for k1,v1 in pairs (xmlModString.Produkte) do
		if moGreenHouse[greenHouseName].capacity[a] == nil then
			moGreenHouse[greenHouseName].capacity[a] = xmlModString.Produkte[k1].capacity;
			moGreenHouse[greenHouseName].fillLevel[a] = xmlModString.Produkte[k1].fillLevel;
			local desc = Fillable.fillTypeIndexToDesc[xmlModString.Produkte[k1].name];
			moGreenHouse[greenHouseName].fillType[a] = false;
			if desc ~= nil then
				moGreenHouse[greenHouseName].fillTypeName[a] = moFillTypes[desc.index].fruitName;
				moGreenHouse[greenHouseName].bestPrice[a] = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
			else				
				moGreenHouse[greenHouseName].bestPrice[a] = 0;
				local nameLength = string.len(xmlModString.Produkte[k1].nameL)				
				if tonumber(nameLength) > 13 and tonumber(moDefault.lengthGreenHouseFillName) < tonumber(nameLength)-13 then moDefault.lengthGreenHouseFillName = tonumber(nameLength)-13;end;
				moGreenHouse[greenHouseName].fillTypeName[a] = xmlModString.Produkte[k1].nameL
			end;
		else
			moGreenHouse[greenHouseName].capacity[a] = moGreenHouse[greenHouseName].capacity[a]+xmlModString.Produkte[k1].capacity;
			moGreenHouse[greenHouseName].fillLevel[a] = moGreenHouse[greenHouseName].fillLevel[a]+xmlModString.Produkte[k1].fillLevel;
		end;
		a = a+1;
	end;	
	for k1,v1 in pairs (xmlModString.Rohstoffe) do
		if moGreenHouse[greenHouseName].capacity[a] == nil then
			moGreenHouse[greenHouseName].capacity[a] = xmlModString.Rohstoffe[k1].capacity;
			moGreenHouse[greenHouseName].fillLevel[a] = xmlModString.Rohstoffe[k1].fillLevel;
			local desc = Fillable.fillTypeIndexToDesc[xmlModString.Rohstoffe[k1].name];
			moGreenHouse[greenHouseName].fillType[a] = true;
			if desc ~= nil then
				moGreenHouse[greenHouseName].fillTypeName[a] = moFillTypes[desc.index].fruitName;
				moGreenHouse[greenHouseName].bestPrice[a] = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
			else
				moGreenHouse[greenHouseName].bestPrice[a] = 0;
				local nameLength = string.len(xmlModString.Rohstoffe[k1].nameL)
				if tonumber(nameLength) > 13 and tonumber(moDefault.lengthGreenHouseFillName) < tonumber(nameLength)-13 then moDefault.lengthGreenHouseFillName = tonumber(nameLength)-13;end;
				moGreenHouse[greenHouseName].fillTypeName[a] = xmlModString.Rohstoffe[k1].nameL
			end;
		else
			moGreenHouse[greenHouseName].capacity[a] = moGreenHouse[greenHouseName].capacity[a]+xmlModString.Rohstoffe[k1].capacity;
			moGreenHouse[greenHouseName].fillLevel[a] = moGreenHouse[greenHouseName].fillLevel[a]+xmlModString.Rohstoffe[k1].fillLevel;
		end;
		a = a+1;
	end;	
end;

function setGreenHouseProductivityMarhu(self, greenHouseName)
	local noProductivity = false;
	local capacityFull = false;	
	for a=1, table.getn(moGreenHouse[greenHouseName].capacity) do
		local fillLevel = moGreenHouse[greenHouseName].fillLevel[a];
		if not moGreenHouse[greenHouseName].fillType[a] then --if tonumber(a) == 1 then
			if tonumber(fillLevel) >= tonumber(moGreenHouse[greenHouseName].capacity[a]) then
				moGreenHouse[greenHouseName].productivityColor = moGuiMiniPDAsetGet.warningColor2; --moGuiExtras.colors['yellow'];
				moGreenHouse[greenHouseName].productivity = string.format("%0.0f", Utils.getNoNil(0, 0));
				capacityFull = true;
			end;
		end;
		if moGreenHouse[greenHouseName].fillType[a] and tonumber(fillLevel) == 0 then --tonumber(a) > 1 and tonumber(fillLevel) == 0 then 
			moGreenHouse[greenHouseName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
			moGreenHouse[greenHouseName].productivity = string.format("%0.0f", Utils.getNoNil(0, 0));
			noProductivity = true;
			break;
		end;
	end;	
	if not capacityFull and not noProductivity then
		moGreenHouse[greenHouseName].productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['green'];
		moGreenHouse[greenHouseName].productivity = string.format("%0.0f", Utils.getNoNil(100, 0));
	end;	
	if tonumber(moDefault.warningGreenHouseProductivity) >= tonumber(moGreenHouse[greenHouseName].productivity) then 
		moDefault.warningGreenHouseProductivity = tonumber(moGreenHouse[greenHouseName].productivity);	
	end;
end;