moDraw.placeableObjects = {};

function moDraw.placeableObjects:setOpenPDA(self)	
	if moDefaultPlaceableObjects.lengthObjects == 0 then
		moGuiMiniPDAsetGet.slotOpen = 0;
		g_currentMission:showBlinkingWarning(unpack(moLanguage.extern['placeableObjectNO'.. moDefault.language]), 2500);
		return;
	end;
	local openSwitchStatus = moGuiMiniPDAsetGet.slotSwitch[moGuiMiniPDAsetGet.slotOpen];
	setTextBold(true);
	local fixDifferenz = 0.007+moSetGetGui.pdaMenueSize/2;
	local posBplaceableObjects = moSetGetGui.pdaMenueSize/3*(32+moDefault.lengthObjectsFillName+moSetGetGui.screenAspectRatio)*1.03;	
	local posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8);
	if moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen] > 0.5 then posX = moGuiMiniPDAsetGet.slotOpenX[moGuiMiniPDAsetGet.slotOpen]+(moSetGetGui.pdaMenueSize*2/1.8)-posBplaceableObjects;end;
	local posY = moGuiMiniPDAsetGet.slotOpenY[moGuiMiniPDAsetGet.slotOpen];
	local posH = moSetGetGui.pdaMenuePosHeight;
	local firstPosXY = posY-(moSetGetGui.pdaMenueSize/1.17);
	local firstPosXYsave = posY-(moSetGetGui.pdaMenueSize/1.17);
	local lengthAllPlaceableObjects = 0;
	local firstLetter = 0.003;
	function nextLine(posNew, setLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-moSetGetGui.pdaMenueLineDif, firstPosXY-moSetGetGui.pdaMenueLineDif-0.002, posBplaceableObjects-fixDifferenz, 0.001);
			moSetGetGui["designLine"]:render();
		end;
		firstPosXY = firstPosXY-(moSetGetGui.pdaMenueSize+posNew);
		posH = posH+moSetGetGui.pdaMenueSize+posNew;
		posY = posY-(moSetGetGui.pdaMenueSize+posNew);
	end;					
	moSetGetGui["designGround"]:render();	
	setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));			
	if moDefaultPlaceableObjects.lengthObjects > 5 then
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['placeableObject'.. moDefault.language]).. "(!switch!)");
	else
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['placeableObject'.. moDefault.language]));
	end;
	nextLine(0.005, true);
	function setPlaceableObjectsDisplay(v)
		lengthAllPlaceableObjects = lengthAllPlaceableObjects+moPlaceableObjects[v].length;				
		setTextBold(true);
		setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableObjects[v].objectName));
		setTextAlignment(RenderText.ALIGN_RIGHT);
		setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
		renderText(posX+(posBplaceableObjects/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableObjects[v].length));				
		setTextAlignment(false);
		nextLine(0.0025);
		setTextBold(false);
		setTextColor(unpack(moPlaceableObjects[v].productivityColor));
		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['productivity'.. moDefault.language]));
		setTextAlignment(RenderText.ALIGN_RIGHT);				
		renderText(posX+(posBplaceableObjects/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableObjects[v].productivity).. "%");	
		setTextAlignment(false);
		--if tostring(v) == "mischstation" or tostring(v) == "saegewerk" or tostring(v) == "ruebenschneider" or tostring(v) == "seedmaster2k15" or tostring(v) == "beetmaster100k" or tostring(v) == "kompostier_anlage" then
			nextLine(0.0025);					
			local foundPalCollector = false;
			for a=1, table.getn(moPlaceableObjects[v].fillCapacity) do
				--local fillNameSplit = nil;
				--if string.find(tostring(moPlaceableObjects[v].fillTypeName[a]), "(", 0, true) then
				--	local splitName = Utils.splitString("(", moPlaceableObjects[v].fillTypeName[a])
				--	if splitName ~= nil and splitName[1] ~= nil and splitName[2] ~= nil then
				--		fillNameSplit = splitName;						
				--	end;
				--end;				
				local capacity = string.format("%0.0f", Utils.getNoNil(moPlaceableObjects[v].fillCapacity[a], 0));
				local fillLevel = string.format("%0.0f", Utils.getNoNil(moPlaceableObjects[v].fillLevel[a], 0));
				setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
				if not moPlaceableObjects[v].fillType[a] then
					--if fillNameSplit ~= nil then
					--	renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(fillNameSplit[1]));
					--	if tostring(v) == "potatowasher" then
					--		nextLine(0.0025);
					--		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "(".. tostring(fillNameSplit[2]));
					--	end;
					--else
					if string.find(moPlaceableObjects[v].fillTypeName[a], "!") then	setTextColor(unpack(moGuiMiniPDAsetGet.warningColor3));end;							
					renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableObjects[v].fillTypeName[a]));
												
					setTextAlignment(RenderText.ALIGN_RIGHT);
					setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
					renderText(posX+(posBplaceableObjects/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(capacity).. " (".. tostring(fillLevel).. ")L");
					setTextAlignment(false);
					if not foundPalCollector and moPlaceableObjects[v].maxPal ~= nil and moPlaceableObjects[v].fremdObj ~= nil then
						nextLine(0.0015);
						foundPalCollector = true;
						setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
						if moPlaceableObjects[v].fremdObj then setTextColor(unpack(moGuiMiniPDAsetGet.warningColor2));end;
						renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, unpack(moLanguage.extern['palCollector'.. moDefault.language]));				
						setTextColor(unpack(moPlaceableObjects[v].palColor));
						setTextAlignment(RenderText.ALIGN_RIGHT);				
						renderText(posX+(posBplaceableObjects/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableObjects[v].maxPal).. "("..tostring(moPlaceableObjects[v].fillPal).. ")Pal");				
						setTextAlignment(false);
					end;
					nextLine(0.0025);
				else
					nextLine(0.0025);
					setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
					--if fillNameSplit ~= nil then
					--	renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(fillNameSplit[1]));
					--	if tostring(v) == "potatowasher" then
					--		nextLine(0.0025);
					--		renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, "(".. tostring(fillNameSplit[2]));
					--	end;
					--else
					if string.find(moPlaceableObjects[v].fillTypeName[a], "!") then	setTextColor(unpack(moGuiMiniPDAsetGet.warningColor4));end;
					renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(moPlaceableObjects[v].fillTypeName[a]));
					--end;							
					setTextAlignment(RenderText.ALIGN_RIGHT);
					setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));						
					renderText(posX+(posBplaceableObjects/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXY, moSetGetGui.pdaMenueSize, tostring(capacity).. " (".. tostring(fillLevel).. ")L");	
					setTextAlignment(false);
					if tostring(v) == "seedmaster2k15" or tostring(v) == "beetmaster100k" or tostring(v) == "kompostier_anlage" then
						nextLine(0.0015);
						setTextColor(unpack(moGuiMiniPDAsetGet.activeColor));
						local stringLength = 0.010/3*(string.len(moPlaceableObjects[v].fillNames))*1.03;
						if posBplaceableObjects >= stringLength then								
							renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, tostring(moPlaceableObjects[v].fillNames));
						else
							local splitNames = Utils.splitString(" ", moPlaceableObjects[v].fillNames)
							renderText(posX+(firstLetter)-(moSetGetGui.pdaMenueSize/5), firstPosXY, 0.010, "too long(".. (table.getn(splitNames)-1).. " fruit names)");
						end;
					end;
				end;												
			end;
		--end;				
		nextLine(0.005, true);
	end;
	function getPlaceableObjectsLength()
		if moDefaultPlaceableObjects.lengthObjects > 5 and tonumber(openSwitchStatus) == 2 then return 6, 10;end;
		if moDefaultPlaceableObjects.lengthObjects > 10 and tonumber(openSwitchStatus) == 3 then return 11, 15;end;
		if moDefaultPlaceableObjects.lengthObjects > 15 and tonumber(openSwitchStatus) == 4 then return 16, 20;end;
		if moDefaultPlaceableObjects.lengthObjects > 20 and tonumber(openSwitchStatus) == 5 then return 21, 25;end;
		if moDefaultPlaceableObjects.lengthObjects > 25 and tonumber(openSwitchStatus) == 6 then return 26, 30;end;
		if moDefaultPlaceableObjects.lengthObjects > 30 and tonumber(openSwitchStatus) == 7 then return 31, 35;end;
		if moDefaultPlaceableObjects.lengthObjects > 35 and tonumber(openSwitchStatus) == 8 then return 36, 40;end;
		return 1, 5;
	end;
	local firstPlaceableObjectsDisplay, maxPlaceableObjectsDisplay = getPlaceableObjectsLength();
	local tempPlaceableObjectsDisplay = 0;
	if moDefaultPlaceableObjects.lengthObjects > 0 then
		local splitObjects = Utils.splitString(" ", moDefaultPlaceableObjects.objects)
		for k, v in pairs (splitObjects) do
			if string.len(v) > 1 and v ~= nil and moPlaceableObjects[v] ~= nil then			
				tempPlaceableObjectsDisplay = tempPlaceableObjectsDisplay+1;
				if tonumber(tempPlaceableObjectsDisplay) >= tonumber(firstPlaceableObjectsDisplay) then					
					if tonumber(firstPlaceableObjectsDisplay) > tonumber(maxPlaceableObjectsDisplay) then break;end;
					firstPlaceableObjectsDisplay = firstPlaceableObjectsDisplay+1;
					setPlaceableObjectsDisplay(v);
				end;
			end;
		end;
	end;	
	---gesamt
	setTextBold(true);
	setTextAlignment(RenderText.ALIGN_RIGHT);
	setTextColor(unpack(moGuiMiniPDAsetGet.siloColor));
	renderText(posX+(posBplaceableObjects/1.12)-(moSetGetGui.pdaMenueSize/5), firstPosXYsave, moSetGetGui.pdaMenueSize, tostring(lengthAllPlaceableObjects));	
	setTextAlignment(false);
	---gesamt		
	moSetGetGui:setOverlay(self, moSetGetGui["designGround"], posX-0.003, posY, posBplaceableObjects-fixDifferenz+0.003, posH);
	moGuiMiniPDAsetGet.slotOpenLastWidth[moGuiMiniPDAsetGet.slotOpen] = posBplaceableObjects-fixDifferenz+0.003;
	moGuiMiniPDAsetGet.slotOpenLastHeight[moGuiMiniPDAsetGet.slotOpen] = posH;	
	setTextBold(false);	
end;